from typing import Optional
from pymemri.data.itembase import Item


class CategoricalPrediction(Item):
    properties = Item.properties + ["source", "value", "probs"]
    edges = Item.edges + ["model"]

    def __init__(self, source: str = None, value: str = None, probs: str = None, model: list = None,**kwargs):
        super().__init__(**kwargs)

        # Properties
        self.source: Optional[str] = source
        self.value: Optional[str] = value
        self.probs = probs

        # Edges
        self.model = model if model is not None else list()


class Model(Item):
    properties = Item.properties + ["name", "version"]

    def __init__(self, name: str = None, version: str = None, **kwargs):
        super().__init__(**kwargs)

        # Properties
        self.name: str = name
        self.version: str = version